Bug 183491 - linux-2.4.20-CAN-2005-0749-elf_dos.patch is incorrect.
linux-2.4.20-CAN-2005-0749-elf_dos.patch is incorrect.
Status: CLOSED ERRATA
Product: Fedora Legacy
Classification: Retired
Component: kernel (Show other bugs)
unspecified
All Linux
medium Severity high
: ---
: ---
Assigned To: Fedora Legacy Bugs
LEGACY, rh73, rh90, 1
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-03-01 10:10 EST by Shuichi KITAGUCHI
Modified: 2007-04-18 13:38 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-03-05 14:16:07 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Shuichi KITAGUCHI 2006-03-01 10:10:49 EST
Description of problem:
linux-2.4.20-CAN-2005-0749-elf_dos.patch in 2.4.20-43.7.legacy is incorrect.
this seems to cause kernel locks up under heavy load.
correct patch is in linux-2.4.21-binfmt-elf.patch from
kernel-2.4.21-27.0.4.EL.src.rpm

problem is here:

diff -Naur linux-2.4.20.ori/fs/binfmt_elf.c linux-2.4.20/fs/binfmt_elf.c
--- linux-2.4.20.ori/fs/binfmt_elf.c	2005-04-25 15:42:21.000000000 -0400
+++ linux-2.4.20/fs/binfmt_elf.c	2005-04-25 18:06:17.000000000 -0400
@@ -846,11 +846,12 @@
 
 static int load_elf_library(struct file *file)
 {
-	struct elf_phdr *elf_phdata;
+	struct elf_phdr *elf_phdata, *elf_phdata_save;
 	unsigned long elf_bss, bss, len;
 	int retval, error, i, j;
 	struct elfhdr elf_ex;
 
+  elf_phdata_save = elf_phdata;     XXX store undecided value to elf_phdata_save
 	error = -ENOEXEC;
 	retval = kernel_read(file, 0, (char *) &elf_ex, sizeof(elf_ex));
 	if (retval != sizeof(elf_ex))
@@ -910,7 +911,7 @@
 	error = 0;
 
 out_free_ph:
-	kfree(elf_phdata);
+	kfree(elf_phdata_save);    XXX kfree undecided value...!
 out:
 	return error;
 }
Comment 1 Marc Deslauriers 2006-03-01 18:04:47 EST
Yep, that looks broken. I'll fix it in the next kernel update.
Comment 2 Marc Deslauriers 2006-03-05 14:16:07 EST
Packages that fix this issue are now in updates-testing.

Note You need to log in before you can comment on or make changes to this bug.